#!/bin/bash

set -euo pipefail

specfile="$1"
dest="$2"

{ echo Changelog; echo =========; echo ""; } > "$dest"
print=false
while read -r line ; do
    if [ "$line" = %changelog ]; then
        print=true
        continue
    fi
    if [ "$print" = false ]; then
        continue
    fi
    if [[ "$line" =~ ^\*\ +[a-zA-Z]+\ +([a-zA-Z]+)\ +([0-9]+)\ +([0-9]+)\ .*-\ +([0-9.-]+)$ ]]; then
        mon="${BASH_REMATCH[1]}"
        day="${BASH_REMATCH[2]}"
        year="${BASH_REMATCH[3]}"
        version="${BASH_REMATCH[4]}"
        datestr=$(date --date="$mon $day $year" +%Y-%m-%d)
        echo ["$version"] - "$datestr"
        echo -------------------------
        echo ""
    elif [[ "$line" =~ ^-\  ]]; then
        # the extra spaces make markdown indent the following lines
        echo "$line  "
    elif [ -z "$line" ]; then
        echo "$line"
    else
        echo "$line  "
    fi
done < "$specfile" >> "$dest"
